# CategorySelector

N 级异步品类 / 品牌联动选择器

业务规则:

1. 一级品类自动获取数据

2. 当仅有一个一级品类，自动选中

3. 需要逐级选择，但 5 级（品牌）可忽略 4 级 （扩展）

4. 当父级全部删除后，清空子代选择框 （待优化）


## 示例

  <demo src="form.jsx" title="在 Form 中使用"></demo>

## API

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| url | 数据请求地址 | String | - |
| max | 最大可选个数 | number | Infinity |
| onMax | 选择超出最大可选个数回调 | function | - |
| layout | 布局类型 | horizontal \| vertical | horizontal |
| itemGap | Select 间距 | number | 10 |
| value | value | Map，参考 demo | - |
| labels | 字段 label，参考 demo | Map | - |
| defaultSelectedTopLevel | 当第一级只有一条数据是，是否默认选中 | bool | true |
| onChange | 选择变更回调, 使用 `getFieldDecorator` 自动注入可忽略 | function | - |

