'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _AutoComplete = require('ola-ui/lib/components/AutoComplete');

var _AutoComplete2 = _interopRequireDefault(_AutoComplete);

var _Icon = require('ola-ui/lib/components/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _olaToolkit = require('ola-toolkit');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _img = require('../../utils/img');

var _style = require('./style.less');

var _style2 = _interopRequireDefault(_style);

var _api = require('../../utils/api');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var ErpSuggestion = (_class = (_temp2 = _class2 = function (_PureComponent) {
  (0, _inherits3.default)(ErpSuggestion, _PureComponent);

  function ErpSuggestion() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ErpSuggestion);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ErpSuggestion.__proto__ || (0, _getPrototypeOf2.default)(ErpSuggestion)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      inputErp: '',
      tip: false
    }, _this.value = null, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ErpSuggestion, [{
    key: 'request',
    value: function request(value) {
      var onSuggestionsFetchRequested = this.props.onSuggestionsFetchRequested;


      onSuggestionsFetchRequested(value);

      value = value.trim();
      if (!value) {
        this.setState({
          tip: false
        });
        return;
      }

      var _props = this.props,
          itemRenderer = _props.itemRenderer,
          filter = _props.filter,
          filterEmptyText = _props.filterEmptyText,
          notFoundText = _props.notFoundText;


      this.setState({
        tip: false
      });

      // Ajax.get({
      //   url: getApiUrl(`/api/demo/erp/find/${value}`),
      // }).then((data) => {
      //   let {list: suggestions} = data;
      //
      //   if (this.value === value) {
      //
      //     if (suggestions.length) {
      //
      //       suggestions = suggestions
      //         .filter(filter)
      //         .map((item, i) => {
      //           return <AutoComplete.Option key={i} text={item.name} item={item}>
      //             {itemRenderer(item)}
      //           </AutoComplete.Option>
      //         });
      //
      //       this.setState({
      //         suggestions: suggestions,
      //         tip: (!suggestions.length && filterEmptyText) ? filterEmptyText : false
      //         // tip: false,
      //       });
      //     } else {
      //       this.setState({
      //         tip: notFoundText,
      //         suggestions: []
      //       });
      //     }
      //   }
      // }).finally(() => {
      //   this.setState({
      //     loading: false,
      //   });
      // });
    }
  }, {
    key: 'getSuggestions',
    value: function getSuggestions(suggestionList) {
      var _props2 = this.props,
          itemRenderer = _props2.itemRenderer,
          filter = _props2.filter,
          filterEmptyText = _props2.filterEmptyText,
          notFoundText = _props2.notFoundText;


      var suggestions = [];

      if (suggestionList.length) {

        suggestions = suggestionList.filter(filter).map(function (item, i) {
          return _react2.default.createElement(
            _AutoComplete2.default.Option,
            { key: i, text: item.name, item: item },
            itemRenderer(item)
          );
        });

        // this.setState({
        //   tip: (!suggestions.length && filterEmptyText) ? filterEmptyText : false
        // });
      } else {
          // this.setState({
          //   tip: notFoundText,
          //   suggestions: []
          // });
        }

      return suggestions;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var tip = this.state.tip;
      var _props3 = this.props,
          _onSelect = _props3.onSelect,
          busy = _props3.busy,
          style = _props3.style,
          autoCompleteStyle = _props3.autoCompleteStyle,
          placeholder = _props3.placeholder,
          suggestionList = _props3.suggestionList;


      var suggestions = this.getSuggestions(suggestionList);

      return _react2.default.createElement(
        'span',
        { style: style },
        _react2.default.createElement(
          'span',
          { style: { marginRight: 10 } },
          _react2.default.createElement(_AutoComplete2.default, {
            style: autoCompleteStyle,
            allowClear: true,
            dataSource: suggestions,
            onSelect: function onSelect(v, _ref2) {
              var item = _ref2.props.item;

              _onSelect(item);
            },
            onChange: function onChange(value) {
              _this2.value = value.trim();
            },
            onSearch: this.request,
            placeholder: placeholder,
            optionLabelProp: 'text'
          })
        ),
        busy && _react2.default.createElement(_Icon2.default, { type: 'loading' }),
        tip && _react2.default.createElement(
          'span',
          null,
          tip
        )
      );
    }
  }]);
  return ErpSuggestion;
}(_react.PureComponent), _class2.propTypes = {

  onSelectErp: _propTypes2.default.func,

  itemRenderer: _propTypes2.default.func,

  style: _propTypes2.default.object,

  autoCompleteStyle: _propTypes2.default.object,

  filter: _propTypes2.default.func,

  // 过滤后为空的提示，一般为过滤的原因，例如重复添加
  filterEmptyText: _propTypes2.default.string,

  notFoundText: _propTypes2.default.string,

  placeholder: _propTypes2.default.string,

  busy: _propTypes2.default.bool,
  suggestionList: _propTypes2.default.array,
  onSuggestionsFetchRequested: _propTypes2.default.func
}, _class2.defaultProps = {

  itemRenderer: function itemRenderer(item) {
    return _react2.default.createElement(
      'span',
      null,
      _react2.default.createElement('img', { src: (0, _img.getAvatar)(item.avatar), className: _style2.default.avatar }),
      item.name,
      '-',
      item.erp,
      '-',
      item.organization
    );
  },

  onSelect: function onSelect() {},

  filter: function filter() {
    return true;
  },

  style: {},

  autoCompleteStyle: {},

  placeholder: '请输入 erp',

  notFoundText: '未检索到此人'

}, _temp2), (_applyDecoratedDescriptor(_class.prototype, 'request', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'request'), _class.prototype)), _class);
exports.default = ErpSuggestion;
module.exports = exports['default'];