'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactAutosuggest = require('react-autosuggest');

var _reactAutosuggest2 = _interopRequireDefault(_reactAutosuggest);

var _Button = require('ola-ui/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('ola-ui/lib/components/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Tooltip = require('ola-ui/lib/components/Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _Input = require('ola-ui/lib/components/Input');

var _Input2 = _interopRequireDefault(_Input);

var _olaToolkit = require('ola-toolkit');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _img = require('../../utils/img');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var ErpSelector = (_class = (_temp2 = _class2 = function (_PureComponent) {
  (0, _inherits3.default)(ErpSelector, _PureComponent);

  function ErpSelector() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ErpSelector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ErpSelector.__proto__ || (0, _getPrototypeOf2.default)(ErpSelector)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      inputErp: '',
      suggestions: [],
      showAdd: true,
      addedErp: new _set2.default(),
      loading: false,
      tip: false
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ErpSelector, [{
    key: 'onSuggestionClearRequested',
    value: function onSuggestionClearRequested() {
      var onSuggestionClearRequested = this.props.onSuggestionClearRequested;


      clearTimeout(this.timer);
      onSuggestionClearRequested();
      // this.setState({
      //   suggestions: [],
      //   loading: false,
      // });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var value = this.props.value;
      var addedErp = this.state.addedErp;


      value = value || [];
      value.forEach(function (member) {
        addedErp.add(member.erp);
      });
    }

    // request(value) {
    //   const {addedErp} = this.state;
    //
    //   this.setState({
    //     loading: true,
    //     tip: false,
    //   });
    //
    //   Ajax.get({
    //     url: `/api/team/find/${value}`
    //   }).then((data) => {
    //     const {inputErp} = this.state;
    //     let {erps: suggestions} = data;
    //
    //     if (inputErp === value) {
    //
    //       if (suggestions.length) {
    //
    //         // 去重
    //         suggestions = suggestions.filter((suggestion) => {
    //           return !addedErp.has(suggestion.erp);
    //         });
    //
    //         this.setState({
    //           suggestions: suggestions,
    //           tip: suggestions.length ? false : '此人已添加'
    //         });
    //       } else {
    //         this.setState({
    //           tip: '未检索到此人',
    //           suggestions: []
    //         });
    //       }
    //     }
    //   }).finally(() => {
    //     this.setState({
    //       loading: false,
    //     });
    //   });
    // }

  }, {
    key: 'onSuggestionsFetchRequested',
    value: function onSuggestionsFetchRequested(_ref2) {
      var value = _ref2.value;
      var onSuggestionsFetchRequested = this.props.onSuggestionsFetchRequested;


      clearTimeout(this.timer);

      this.timer = setTimeout(function () {
        onSuggestionsFetchRequested(value);
      }, 200);
    }
  }, {
    key: 'onSuggestionSelected',
    value: function onSuggestionSelected(event, _ref3) {
      var suggestion = _ref3.suggestion,
          suggestionValue = _ref3.suggestionValue,
          suggestionIndex = _ref3.suggestionIndex,
          sectionIndex = _ref3.sectionIndex,
          method = _ref3.method;
      var _props = this.props,
          value = _props.value,
          onChange = _props.onChange;
      var addedErp = this.state.addedErp;


      value = value || [];

      onChange(value.concat(suggestion));
      addedErp.add(suggestion.erp);

      this.setState({
        inputErp: '',
        showAdd: true,
        tip: false
      });
    }
  }, {
    key: 'onInputChange',
    value: function onInputChange(e) {
      if (e.target.value !== undefined) {
        this.setState({
          inputErp: e.target.value
        });
      }
    }
  }, {
    key: 'deleteItem',
    value: function deleteItem(member) {
      var _props2 = this.props,
          onChange = _props2.onChange,
          value = _props2.value;
      var addedErp = this.state.addedErp;

      onChange(value.filter(function (item) {
        if (item.erp === member.erp) {
          addedErp.delete(member.erp);
          return false;
        }
        return true;
      }));
    }
  }, {
    key: 'addField',
    value: function addField() {
      var _this2 = this;

      this.setState({
        showAdd: false
      }, function () {
        var dom = _reactDom2.default.findDOMNode(_this2).querySelector('input');
        if (dom) {
          dom.focus();
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props3 = this.props,
          name = _props3.name,
          className = _props3.className,
          size = _props3.size,
          style = _props3.style,
          busy = _props3.busy,
          _props3$value = _props3.value,
          value = _props3$value === undefined ? [] : _props3$value,
          type = _props3.type,
          max = _props3.max,
          suggestionList = _props3.suggestionList,
          inputPlaceholder = _props3.inputPlaceholder;
      var _state = this.state,
          inputErp = _state.inputErp,
          showAdd = _state.showAdd,
          tip = _state.tip,
          addedErp = _state.addedErp;

      var styles = require('./style.less');

      var suggestions = [];
      if (suggestionList.length) {

        // 去重
        suggestions = suggestionList.filter(function (suggestion) {
          return !addedErp.has(suggestion.erp);
        });
      } else {
        // this.setState({
        //   tip: '未检索到此人',
        //   suggestions: []
        // });
      }

      var items = value ? value.map(function (member, index) {
        return _react2.default.createElement(
          'span',
          { key: index, style: { lineHeight: '26px' }, className: styles.selectedBtn + ' ' + styles.item },
          _react2.default.createElement(
            _Tooltip2.default,
            { title: member.erp, placement: 'bottom' },
            member.name
          ),
          !member.fixed && _react2.default.createElement(_Icon2.default, { className: styles.removeIcon, type: 'close', onClick: function onClick() {
              _this3.deleteItem(member);
            } })
        );
      }) : null;

      return _react2.default.createElement(
        'div',
        { className: className, style: style },
        !showAdd && _react2.default.createElement(_reactAutosuggest2.default, {
          suggestions: suggestions,
          focusInputOnSuggestionClick: false,
          onSuggestionSelected: this.onSuggestionSelected,
          onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
          onSuggestionsClearRequested: this.onSuggestionClearRequested,
          getSuggestionValue: function getSuggestionValue(suggestion) {
            return suggestion.name;
          },
          renderSuggestion: function renderSuggestion(item) {
            return _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('img', { src: (0, _img.getAvatar)(item.avatar), className: styles.avatar }),
              item.name,
              '-',
              item.erp,
              '-',
              item.organization
            );
          },
          inputProps: {
            value: inputErp,
            onChange: this.onInputChange,
            className: '' + styles.input,
            placeholder: inputPlaceholder
          },
          renderInputComponent: function renderInputComponent(inputProps) {
            return _react2.default.createElement(_Input2.default, (0, _extends3.default)({ size: size }, inputProps, { suffix: busy ? _react2.default.createElement(_Icon2.default, { type: 'loading' }) : null }));
          },

          theme: {
            container: styles.container,
            suggestionsContainer: styles.suggestionsContainer,
            suggestionsList: styles.suggestionsList + ' ant-select-dropdown-menu ant-select-dropdown-menu-vertical',
            suggestion: styles.suggestion + ' ant-select-dropdown-menu-item',
            suggestionHighlighted: 'active'
          }
        }),
        showAdd && max > value.length && _react2.default.createElement(
          _Button2.default,
          { type: 'dashed', size: size, className: styles.addBtn, onClick: this.addField },
          _react2.default.createElement(_Icon2.default, { type: 'plus' }),
          ' \u6DFB\u52A0'
        ),
        items && items.length > 0 && _react2.default.createElement(
          'div',
          { style: max > value.length ? { paddingTop: 10 } : {} },
          items
        )
      );
    }
  }]);
  return ErpSelector;
}(_react.PureComponent), _class2.propTypes = {
  max: _propTypes2.default.number,
  value: _propTypes2.default.array,
  onChange: _propTypes2.default.func,
  onSuggestionClearRequested: _propTypes2.default.func,
  onSuggestionsFetchRequested: _propTypes2.default.func,
  busy: _propTypes2.default.bool,
  suggestionList: _propTypes2.default.array,
  size: _propTypes2.default.oneOf(['small', 'default', 'large']),
  inputPlaceholder: _propTypes2.default.string,
  className: _propTypes2.default.string,
  style: _propTypes2.default.object
}, _class2.defaultProps = {
  max: Number.MAX_VALUE,
  onSuggestionClearRequested: function onSuggestionClearRequested() {},
  onSuggestionsFetchRequested: function onSuggestionsFetchRequested() {},
  suggestionList: [],
  busy: false,
  onChange: function onChange() {},
  size: 'default',
  inputPlaceholder: '',
  className: '',
  style: {}
}, _temp2), (_applyDecoratedDescriptor(_class.prototype, 'onSuggestionClearRequested', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onSuggestionClearRequested'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onSuggestionsFetchRequested', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onSuggestionsFetchRequested'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onSuggestionSelected', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onSuggestionSelected'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onInputChange', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onInputChange'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'deleteItem', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'deleteItem'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'addField', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'addField'), _class.prototype)), _class);

/*
export default class ErpSelector extends PureComponent {

  static propTypes = {

    max: PropTypes.number,

    value: PropTypes.array,

    onChange: PropTypes.func,

    suggestionList: PropTypes.array,

    onSuggestionsFetchRequested: PropTypes.func,

    busy: PropTypes.bool,
  };

  static defaultProps = {

    max: Number.MAX_SAFE_INTEGER,

    value: [],

    onChange: () => {
    },

    suggestionList: [],

    onSuggestionsFetchRequested: () => {
    },

    busy: false,
  };

  state = {
    inputErp: '',
    suggestions: [],
    showAdd: true,
    addedErp: new Set(),
    tip: false,
  };

  componentWillMount() {
    let {value} = this.props;
    const {addedErp} = this.state;

    value.forEach((member) => {
      addedErp.add(member.erp);
    });
  }


  @bind
  onSuggestionsFetchRequested({value}) {

    clearTimeout(this.timer);

    this.timer = setTimeout(() => {
      this.request(value);
    }, 200);

  }

  @bind
  onSuggestionSelected(suggestion) {

    const {onChange, value} = this.props;
    const {addedErp} = this.state;

    onChange(value.concat([], suggestion));

    addedErp.add(suggestion.erp);

    this.setState({
      inputErp: '',
      showAdd: true,
      tip: false,
    });

  }

  @bind
  onInputChange(e) {
    if (e.target.value !== undefined) {
      this.setState({
        inputErp: e.target.value,
      });
    }
  }

  @bind
  deleteItem(member) {
    let {onChange, value} = this.props;
    const {addedErp} = this.state;
    onChange(value.filter(item => {
      if (item.erp === member.erp) {
        addedErp.delete(member.erp);
        return false;
      }
      return true;
    }));

  }

  @bind
  addField() {
    this.setState({
      showAdd: false
    }, () => {
      const dom = ReactDom.findDOMNode(this).querySelector('input');
      if (dom) {
        dom.focus();
      }
    });
  }

  @bind
  suggestionFilter(suggestion) {
    const {value} = this.props;
    const {addedErp} = this.state;
    return !addedErp.has(suggestion.erp);
  }

  render() {

    const {name, className, placeholder, value, busy, type, max, suggestionList, onSuggestionsFetchRequested} = this.props;
    const {inputErp, suggestions, showAdd, tip} = this.state;

    const styles = require('./styles.less');

    let items = value ? value.map((member, index) => {
      return <span key={index} style={{lineHeight: '26px'}} className={`btn-removable ${styles.item}`}>
                <Tooltip title={member.erp} placement="bottom">
                {member.name}
                </Tooltip>
        {!member.fixed &&
        <span className="btn-removable-action">
            <Icon type="close" onClick={() => {
              this.deleteItem(member);
            }}/>
        </span>
        }
            </span>;
    }) : null;

    return <div>
      <div>
        {!showAdd && <ErpSuggestion
          autoCompleteStyle={{width: 250}}
          onSelect={this.onSuggestionSelected}
          filter={this.suggestionFilter}
          filterEmptyText={`此人已添加`}
          suggestionList={suggestionList}
          busy={busy}
          onSuggestionsFetchRequested={onSuggestionsFetchRequested}
        />}

        {showAdd && max > value.length &&
        <Button type="dashed" className={styles.addBtn} onClick={this.addField}>
          <Icon type="plus"/> 添加
        </Button>
        }
      </div>
      {(items && items.length > 0) &&
      <div style={max > value.length ? {paddingTop: 10,} : {}}>
        {items}
      </div>}
    </div>
  }

}
*/

exports.default = ErpSelector;
module.exports = exports['default'];