'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _olaToolkit = require('ola-toolkit');

var _Spin = require('ola-ui/lib/components/Spin');

var _Spin2 = _interopRequireDefault(_Spin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FillPrice = function (_PureComponent) {
  (0, _inherits3.default)(FillPrice, _PureComponent);

  function FillPrice() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FillPrice);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FillPrice.__proto__ || (0, _getPrototypeOf2.default)(FillPrice)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      skuList: [],
      loading: false,
      errorMsg: ''
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(FillPrice, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var me = this;
      var _props = this.props,
          _props$list = _props.list,
          skuList = _props$list === undefined ? [] : _props$list,
          _props$pageSize = _props.pageSize,
          pageSize = _props$pageSize === undefined ? 10 : _props$pageSize;

      var skuIds = skuList.map(function (item) {
        return item.skuId;
      });
      var skuIdsCount = skuIds.length;
      var groupNum = skuIdsCount % pageSize == 0 ? skuIdsCount / pageSize : parseInt(skuIdsCount / pageSize) + 1;
      var getSkuIdsInfo = function () {
        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
          var getSkuPriceTaskQueue, i, getSkuPrice;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;

                  // 创建获取sku价格任务队列
                  getSkuPriceTaskQueue = [];

                  for (i = 0; i < groupNum; i++) {
                    getSkuPrice = function getSkuPrice(skuIdsGroup) {
                      return _olaToolkit.Ajax.get({
                        url: '//p.3.cn/prices/mgets',
                        jsonp: true,
                        turnoffAdaptor: true,
                        params: {
                          skuIds: skuIdsGroup.map(function (item) {
                            return 'J_' + item;
                          }).join(','),
                          source: 'iop'
                        }
                      }).then(function (group) {
                        group.map(function (item) {
                          for (var _i = 0; _i < skuList.length; _i++) {
                            if (item.id.replace('J_', '') == skuList[_i].skuId + '') {
                              // 为sku信息注入价格信息
                              skuList[_i] = (0, _assign2.default)({}, skuList[_i], item);
                            }
                          }
                        });
                      });
                    };

                    getSkuPriceTaskQueue.push(getSkuPrice((0, _assign2.default)([], skuIds).splice(i * pageSize, pageSize)));
                  }

                  // 并行获取sku价格任务队列
                  _context.next = 5;
                  return _promise2.default.all(getSkuPriceTaskQueue);

                case 5:
                  return _context.abrupt('return', skuList);

                case 8:
                  _context.prev = 8;
                  _context.t0 = _context['catch'](0);
                  return _context.abrupt('return', new _promise2.default(function (resolve, reject) {
                    reject(_context.t0);
                  }));

                case 11:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 8]]);
        }));

        return function getSkuIdsInfo() {
          return _ref2.apply(this, arguments);
        };
      }();

      me.setState({
        loading: true,
        errorMsg: ''
      });

      getSkuIdsInfo().then(function (skuList) {
        console.log(skuList);
        me.setState({
          skuList: skuList
        });
      }).catch(function (e) {
        console.log(e);
        me.setState({
          skuList: skuList,
          errorMsg: '价格获取失败'
        });
      }).finally(function () {
        me.setState({
          loading: false
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          _props2$list = _props2.list,
          list = _props2$list === undefined ? [] : _props2$list,
          dataKey = _props2.dataKey;
      var _state = this.state,
          _state$skuList = _state.skuList,
          stateSkuList = _state$skuList === undefined ? [] : _state$skuList,
          loading = _state.loading,
          errorMsg = _state.errorMsg;

      var skuList = stateSkuList.length > 0 ? stateSkuList : list;

      // 传到子组件的props
      var childrenProps = (0, _defineProperty3.default)({
        loading: loading,
        errorMsg: errorMsg
      }, dataKey, skuList);

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.cloneElement(this.props.children, childrenProps)
      );
    }
  }]);
  return FillPrice;
}(_react.PureComponent); /*
                         * Author: cdzhongpeizhi@jd.com
                         * Desc: 该组件接收一个sku信息列表（列表每一项都包含skuId属性），通过调用JD实时价接口，为每一项sku信息中注入jd实时价格信息。
                         * @props list: array  包含sku信息的数组，每项必需要有一个skuId属性。
                         * @props dataKey: 子组件接受的sku列表的props名称，用于将解析后的数据注入到子组件。
                         */

exports.default = FillPrice;
module.exports = exports['default'];