import React, {Component} from 'react';
import {Switch} from 'ola-ui';
import {Forbidden} from 'ola-ui-jd';

export default class Demo extends Component {

  state = {
    showFooter: true,
  };

  render() {
    const {showFooter} = this.state;
    return <div style={{padding: 20}}>

      <Switch checkedChildren="Footer On" unCheckedChildren="Footer Off" checked={showFooter} onChange={showFooter => {
        this.setState({showFooter});
      }}/>

      <Forbidden
        contacts={[{
          name: '张鹏飞',
          erp: 'zhangpengfei45',
          email: 'cdzhangpengfei6@jd.com'
        }, {
          name: '贾曰平',
          erp: 'jiayutping',
          email: 'cdjiayueping@jd.com',
        }]}
        footer={showFooter}
      />
    </div>
  }
}
