'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Spin = require('ola-ui/lib/components/Spin');

var _Spin2 = _interopRequireDefault(_Spin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var typesEnum = {

  joy: _react2.default.createElement('img', { style: { width: 100 }, src: '//misc.360buyimg.com/mtd/pc/index_2017/2.1.0/static/images/lazyload.gif',
    srcSet: '//misc.360buyimg.com/mtd/pc/index_2017/2.1.0/static/images/lazyload@2x.gif 2x' }),

  logo: _react2.default.createElement('img', { style: { width: 25 }, src: '//misc.360buyimg.com/mtd/pc/index_2017/2.1.0/static/images/loading.gif',
    srcSet: '//misc.360buyimg.com/mtd/pc/index_2017/2.1.0/static/images/loading@2x.gif 2x' }),

  spin: _react2.default.createElement(_Spin2.default, null)

};

var Loading = (_temp = _class = function (_PureComponent) {
  (0, _inherits3.default)(Loading, _PureComponent);

  function Loading(props) {
    (0, _classCallCheck3.default)(this, Loading);
    return (0, _possibleConstructorReturn3.default)(this, (Loading.__proto__ || (0, _getPrototypeOf2.default)(Loading)).call(this, props));
  }

  (0, _createClass3.default)(Loading, [{
    key: 'render',
    value: function render() {
      var styles = require('./styles.less');
      var _props = this.props,
          type = _props.type,
          text = _props.text,
          style = _props.style,
          className = _props.className,
          indicator = _props.indicator,
          children = _props.children,
          busy = _props.busy,
          overlayOpacity = _props.overlayOpacity,
          textStyle = _props.textStyle;


      var loadingIndicator = indicator ? indicator : typesEnum[type];
      var asContainer = !!children;

      var asContainerStyle = asContainer ? {
        position: 'relative'
      } : {};

      var textBrightness = overlayOpacity;

      if (textBrightness > .5) {
        textBrightness = .9;
      } else {
        textBrightness = .1;
      }

      return _react2.default.createElement(
        'div',
        { className: className, style: (0, _assign2.default)(asContainerStyle, style) },
        busy && _react2.default.createElement(
          'span',
          { className: styles.container + ' ' + (asContainer ? styles.wrapper : ''), style: asContainer ? {
              background: 'rgba(0,0,0, ' + overlayOpacity + ')'
            } : {} },
          loadingIndicator,
          _react2.default.createElement(
            'span',
            { className: styles.text, style: (0, _assign2.default)(asContainer ? {
                color: 'hsl(0,0%,' + textBrightness * 100 + '%)'
              } : {}, textStyle) },
            text
          )
        ),
        children
      );
    }
  }]);
  return Loading;
}(_react.PureComponent), _class.propTypes = {

  style: _propTypes2.default.object,

  className: _propTypes2.default.string,

  type: _propTypes2.default.oneOf(['joy', 'logo', 'spin']),

  indicator: _propTypes2.default.element,

  text: _propTypes2.default.string,

  textStyle: _propTypes2.default.object,

  busy: _propTypes2.default.bool,

  overlayOpacity: _propTypes2.default.number
}, _class.defaultProps = {
  style: {},

  className: '',

  type: 'logo',

  textStyle: {},

  busy: true,

  overlayOpacity: 0
}, _temp);
exports.default = Loading;
module.exports = exports['default'];