# OlaHeader

欧拉应用统一 Header

## 示例

  <demo src="basic.jsx" title="基础用法"></demo>
  
  <demo src="nav.jsx" title="添加导航"></demo>

## API

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| style | 容器样式 | object | {} |
| className | className | string | - |
| app | 应用编号 | string | - |
| textApp | 应用名，如果应用无图标，可以用此选项替代 | string | - |
| logoTitle | 用于 logo 的 title 属性 | string | - |
| logoLink | logo 链接 | string | / |
| onLogoClick | logo 链接 click 回调 | function(e) | - |
| left | 左侧扩展区域 | ReactNode | - |
| center | 中间扩展区域 | ReactNode | - |
| right | 右侧扩展区域 | ReactNode | - |
| userName | 自定义登录用户名 | string | window.\_\_OLA_ERP\_\_ |
| businessLines | 业务线 | array \| Immutable.List | - |
| businessLineSelected | 选中的业务线 | string | - |
| onBusinessLineChange | 业务线选中回调 | function(selected) | - |
| Link | react-router-dom Link 组件 | PropTypes.func \| PropTypes.string | 'a' |
| theme | 主题 | light \| dark | 'light' |
| showHomeLink | 显示欧拉首页链接 | bool | true |
| logoutUrl | 自定义登出操作链接 | sting | - |
