import React, {Component} from 'react';
import {OlaHeader} from "ola-ui-jd";
import Immutable from 'immutable';

const style = {margin: '10px 0 40px'};

export default class Demo extends Component {

  state = {
    businessLines: Immutable.List(['京东服饰', '闪购', '全球购']),
    businessLineSelected: '京东服饰',
  };

  render() {
    const {businessLines, businessLineSelected} = this.state;

    return <div>
      <OlaHeader
        app={'huixuan'}
        title={'慧选 --- 智能选品'}
        slogan={''}
        style={style}
        businessLines={businessLines}
        businessLineSelected={businessLineSelected}
        userName={'bjadmin'}
        onBusinessLineChange={businessLineSelected => {
          this.setState({businessLineSelected})
        }}
      />
    </div>;
  }

}
