'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Icon = require('ola-ui/lib/components/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _index = require('./index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isDev = process.env.NODE_ENV !== 'production';

var Helpers = (_temp = _class = function (_PureComponent) {
  (0, _inherits3.default)(Helpers, _PureComponent);

  function Helpers(props) {
    (0, _classCallCheck3.default)(this, Helpers);
    return (0, _possibleConstructorReturn3.default)(this, (Helpers.__proto__ || (0, _getPrototypeOf2.default)(Helpers)).call(this, props));
  }

  (0, _createClass3.default)(Helpers, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          logoutUrl = _props.logoutUrl,
          returnUrl = _props.returnUrl,
          userName = _props.userName,
          className = _props.className;


      var jumpUrl = logoutUrl || '//' + (isDev ? 'test.' : '') + 'ssa.jd.com/sso/logout?returnUrl=' + encodeURIComponent(location.href);

      return _react2.default.createElement(
        'span',
        { style: style, className: '' + className },
        _react2.default.createElement(
          'span',
          { className: (0, _index.getClass)('userName') },
          userName
        ),
        _react2.default.createElement(
          'a',
          { href: '#',
            className: (0, _index.getClass)('logout'),
            onClick: function onClick(e) {
              e.preventDefault();
              location.href = jumpUrl;
            }
          },
          _react2.default.createElement(_Icon2.default, { type: 'logout-square' })
        )
      );
    }
  }]);
  return Helpers;
}(_react.PureComponent), _class.propTypes = {

  userName: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element, _propTypes2.default.node]),

  logoutUrl: _propTypes2.default.string,

  returnUrl: _propTypes2.default.string,

  className: _propTypes2.default.string,

  style: _propTypes2.default.object

}, _class.defaultProps = {

  className: '',

  style: {},

  logoutUrl: '',

  userName: window.__OLA_ERP__,

  returnUrl: window.___OLA_RETURN_URL__ || location.href

}, _temp);
exports.default = Helpers;
module.exports = exports['default'];