"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeAsyncActionTypes = makeAsyncActionTypes;
exports.makeToggleActionTypes = makeToggleActionTypes;
var ACTION_PREFIX = exports.ACTION_PREFIX = "@@oujd";

function makeAsyncActionTypes(actionKey) {
  return {
    fetch: ACTION_PREFIX + "/" + actionKey + "/fetch",
    success: ACTION_PREFIX + "/" + actionKey + "/fulfilled",
    update: ACTION_PREFIX + "/" + actionKey + "/update",
    fail: ACTION_PREFIX + "/" + actionKey + "/rejected",
    clear: ACTION_PREFIX + "/" + actionKey + "/clear"
  };
}

function makeToggleActionTypes(actionKey) {
  return {
    on: ACTION_PREFIX + "/" + actionKey + "/on",
    off: ACTION_PREFIX + "/" + actionKey + "/off"
  };
}