'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Icon = require('ola-ui/lib/components/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Select = require('ola-ui/lib/components/Select');

var _Select2 = _interopRequireDefault(_Select);

var _Loading = require('../Loading');

var _Loading2 = _interopRequireDefault(_Loading);

var _olaToolkit = require('ola-toolkit');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var Option = _Select2.default.Option;
var LoadingContent = _react2.default.createElement(_Loading2.default, { type: 'logo', text: '...加载中...' });

var Exception = function Exception(props) {
  return _react2.default.createElement(
    'div',
    { style: { textAlign: 'center' } },
    _react2.default.createElement(
      'div',
      { style: { color: '#856404' } },
      _react2.default.createElement(_Icon2.default, { type: 'exclamation-circle-o', style: { paddingRight: 5 } }),
      props.text
    )
  );
};

var CateSelectorDumb = (_class = (_temp = _class2 = function (_PureComponent) {
  (0, _inherits3.default)(CateSelectorDumb, _PureComponent);

  function CateSelectorDumb() {
    (0, _classCallCheck3.default)(this, CateSelectorDumb);
    return (0, _possibleConstructorReturn3.default)(this, (CateSelectorDumb.__proto__ || (0, _getPrototypeOf2.default)(CateSelectorDumb)).apply(this, arguments));
  }

  (0, _createClass3.default)(CateSelectorDumb, [{
    key: 'onSelect',
    value: function onSelect(key, selected) {
      var onSelect = this.props.onSelect;


      onSelect(key, selected);
    }
  }, {
    key: 'onFocus',
    value: function onFocus(key) {
      var onFocus = this.props.onFocus;


      onFocus(key);
    }
  }, {
    key: 'onSearch',
    value: function onSearch(key, keyword) {
      var onSearch = this.props.onSearch;

      onSearch(key, keyword);
    }
  }, {
    key: 'onDeselect',
    value: function onDeselect(key, code) {
      var onDeselect = this.props.onDeselect;

      onDeselect(key, code);
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var onRequestTopLevel = this.props.onRequestTopLevel;


      onRequestTopLevel();
    }
  }, {
    key: 'renderNotFoundContent',
    value: function renderNotFoundContent(key) {
      var data = this.props.data;


      var error = data.getIn([key, 'error']);
      var loading = data.getIn([key, 'loading']);

      if (error) {
        return _react2.default.createElement(Exception, { text: data.getIn([key, 'error', 'msg']) });
      } else if (loading) {
        return LoadingContent;
      } else {
        // return <Exception text={'请先选择上一级'}/>;
        return null;
      }
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren(key) {
      var _props = this.props,
          data = _props.data,
          value = _props.value;

      var list = data.getIn([key, 'list']);
      var count = data.getIn([key, 'count']);

      var undefinedName = 0;

      var options = list.map(function (item) {
        undefinedName += item.get('name') === undefined ? 1 : 0;

        return _react2.default.createElement(
          Option,
          { value: item.get('code'), key: item.get('code') },
          item.get('name')
        );
      });

      if (options.size && count) {
        if (count > 100) {
          options = options.push(_react2.default.createElement(
            Option,
            { key: 'count', disabled: true },
            '\u5171 ',
            count,
            ' \u4E2A\u7ED3\u679C\uFF0C\u8BF7\u8F93\u5165\u4EE5\u68C0\u7D22'
          ));
        }
      }

      // if(undefinedName > 0) {

      // const loading = data.getIn([key, 'loading']);

      // console.log('focus', key, options.size, loading);


      // this.onFocus(key);
      // }

      return options;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          data = _props2.data,
          keys = _props2.keys,
          value = _props2.value,
          options = _props2.options,
          radioGroupProps = _props2.radioGroupProps,
          className = _props2.className,
          style = _props2.style,
          layout = _props2.layout,
          itemGap = _props2.itemGap,
          labels = _props2.labels,
          getPopupContainer = _props2.getPopupContainer;

      var styles = require('./style.less');

      var itemStyle = (0, _defineProperty3.default)({
        width: '100%'
      }, layout === 'vertical' ? 'marginBottom' : 'marginRight', itemGap);

      var selections = keys.map(function (key, index) {

        var topLevel = index === 0;

        return _react2.default.createElement(
          _Select2.default,
          {
            key: key,
            className: styles.select,
            mode: 'multiple',
            style: itemStyle,
            placeholder: labels.get(key),
            optionFilterProp: 'children',
            notFoundContent: _this2.renderNotFoundContent(key),
            onSelect: function onSelect(selected) {
              _this2.onSelect(key, selected);
            },
            onFocus: function onFocus() {
              !topLevel && _this2.onFocus(key);
            },
            onDeselect: function onDeselect(v) {
              _this2.onDeselect(key, v);
            },
            onSearch: function onSearch(keyword) {
              _this2.onSearch(key, keyword);
            },
            filterOption: function filterOption(inputValue, option) {
              return true;
            },
            value: value.get(key).map(function (v) {
              return v.get('code');
            }).toArray(),
            getPopupContainer: getPopupContainer
          },
          _this2.renderChildren(key)
        );
      });

      return _react2.default.createElement(
        'div',
        { className: styles.container + ' ' + styles[layout] },
        selections
      );
    }
  }]);
  return CateSelectorDumb;
}(_react.PureComponent), _class2.propTypes = {

  onRequestTopLevel: _propTypes2.default.func.isRequired,

  data: _propTypes2.default.object,

  onSelect: _propTypes2.default.func,

  value: _propTypes2.default.object,

  keys: _propTypes2.default.object,

  layout: _propTypes2.default.oneOf(['horizontal', 'vertical']),

  getPopupContainer: _propTypes2.default.func,

  itemGap: _propTypes2.default.number
}, _class2.defaultProps = {
  getPopupContainer: function getPopupContainer() {
    return document.body;
  },
  layout: 'horizontal',
  itemGap: 10
}, _temp), (_applyDecoratedDescriptor(_class.prototype, 'onSelect', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onSelect'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onFocus', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onFocus'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onSearch', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onSearch'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onDeselect', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onDeselect'), _class.prototype)), _class);
exports.default = CateSelectorDumb;
module.exports = exports['default'];