'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _maxSafeInteger = require('babel-runtime/core-js/number/max-safe-integer');

var _maxSafeInteger2 = _interopRequireDefault(_maxSafeInteger);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _dumb = require('./dumb');

var _dumb2 = _interopRequireDefault(_dumb);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _olaToolkit = require('ola-toolkit');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var initState = _immutable2.default.Map({
  loading: false,
  error: null,
  list: [],
  value: {}
});

var CategorySelector = (_class = (_temp2 = _class2 = function (_PureComponent) {
  (0, _inherits3.default)(CategorySelector, _PureComponent);

  function CategorySelector() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, CategorySelector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CategorySelector.__proto__ || (0, _getPrototypeOf2.default)(CategorySelector)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      // data: Immutable.Map({
      //   1: initState,
      //   2: initState,
      //   3: initState,
      //   4: initState,
      // }),

      // 每个 key 对应的数据状态
      data: function () {
        var data = _immutable2.default.Map();
        _this.props.value.forEach(function (item, key) {
          data = data.set(key, initState);
          if (item.size) {
            data = data.setIn([key, 'list'], item);
          }
        });
        return data;
      }(),

      keys: _this.props.value.keySeq().toList()
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(CategorySelector, [{
    key: 'onSelect',


    /**
     *
     * @param key
     * @param selectedCode code
     */
    value: function onSelect(key, selectedCode) {
      var _props = this.props,
          value = _props.value,
          onChange = _props.onChange,
          max = _props.max,
          onMax = _props.onMax;


      var selectedList = value.get(key).push(_immutable2.default.Map({
        code: selectedCode
      }));

      if (selectedList.size > max) {
        onMax(max);
        return;
      }

      var newValue = value.setIn([key], selectedList);

      onChange(newValue);
    }
  }, {
    key: 'onDeselect',
    value: function onDeselect(key, code) {
      var _state = this.state,
          keys = _state.keys,
          data = _state.data;
      var _props2 = this.props,
          value = _props2.value,
          onChange = _props2.onChange;

      var level = keys.indexOf(key);
      var newValue = value;

      while (++level < keys.size) {
        // newValue = newValue.set(keys.get(level), Immutable.List());
        // clear select children
        data = data.setIn([keys.get(level), 'error'], null).setIn([keys.get(level), 'loading'], false).setIn([keys.get(level), 'list'], _immutable2.default.List()).setIn([keys.get(level), 'count'], 0);
      }

      // newValue = newValue.deleteIn([key, newValue.get(key).indexOf(code)]);
      newValue = newValue.deleteIn([key, newValue.get(key).findIndex(function (option) {
        return option.get('code') === code;
      })]);

      // all deleted
      if (!newValue.get(key).size) {
        var _level = keys.indexOf(key);
        while (++_level < keys.size) {
          newValue = newValue.set(keys.get(_level), _immutable2.default.List());
        }
      }

      onChange(newValue);
      this.setState({ data: data });
    }
  }, {
    key: 'onRequest',
    value: function onRequest(key, keyword) {
      var _state2 = this.state,
          keys = _state2.keys,
          data = _state2.data;
      var value = this.props.value;


      var level = keys.indexOf(key);

      var parentKey = keys.get(level - 1);
      var parentSelected = value.get(parentKey);

      // const parents = keys.take(level);
      // console.log(`parents`, parents.toJS());

      if (level === 4) {
        // TODO 第5级可以忽略第四级的选择
        if (!parentSelected.size) {
          var level2Key = keys.get(2);
          var level2Selected = value.get(level2Key);
          if (level2Selected.size) {
            var _param;

            var param = (_param = {}, (0, _defineProperty3.default)(_param, level2Key, level2Selected.map(function (v) {
              return v.get('code');
            }).toArray()), (0, _defineProperty3.default)(_param, 'brandCode', 1), (0, _defineProperty3.default)(_param, 'query', keyword), _param);

            this.requestData(key, param);
            return;
          } else {
            this.setState({
              data: data.setIn([key, 'error'], _immutable2.default.Map({ msg: '请先选择上一级' })).setIn([key, 'loading'], false)
            });
          }
        }
      }

      if (parentSelected.size) {
        var _param3;

        var _param2 = (_param3 = {}, (0, _defineProperty3.default)(_param3, parentKey, parentSelected.map(function (v) {
          return v.get('code');
        }).toArray()), (0, _defineProperty3.default)(_param3, 'query', keyword), _param3);

        this.requestData(key, _param2);
      } else {
        this.setState({
          data: data.setIn([key, 'error'], _immutable2.default.Map({ msg: '请先选择上一级' })).setIn([key, 'loading'], false)
        });
      }
    }
  }, {
    key: 'requestData',
    value: function requestData(key) {
      var _this2 = this;

      var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _props3 = this.props,
          value = _props3.value,
          url = _props3.url,
          defaultSelectedTopLevel = _props3.defaultSelectedTopLevel;
      var _state3 = this.state,
          data = _state3.data,
          keys = _state3.keys;

      // const loading = data.getIn([key, 'loading']);
      // console.log('loading', key, loading, params);

      this.setState({
        data: data.setIn([key, 'loading'], true).setIn([key, 'list'], _immutable2.default.List()).setIn([key, 'error'], null)
      });

      _olaToolkit.Ajax.get({
        url: url,
        withCredentials: true,
        params: params
      }).then(function (rsp) {
        rsp = _immutable2.default.fromJS(rsp);
        var list = rsp.get('list');
        var level = keys.indexOf(key);
        if (list.size) {
          _this2.setState({
            data: data.setIn([key, 'error'], null).setIn([key, 'loading'], false).setIn([key, 'list'], list.take(100)).setIn([key, 'count'], rsp.get('count'))
          }, function () {
            if (defaultSelectedTopLevel && level === 0) {
              // 对于一级，无值则默认选中第一个
              if (!value.get(keys.get(0)).size && list.size === 1) {
                _this2.onSelect(key, list.getIn([0, 'code']));
              }
            }
          });
        } else {
          _this2.setState({
            data: data.setIn([key, 'error'], _immutable2.default.Map({ msg: '未查询到内容' })).setIn([key, 'loading'], false)
          });
        }
      }).catch(function (e) {

        _this2.setState({
          data: data.setIn([key, 'error'], e).setIn([key, 'loading'], false)
        });
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      // const {value} = this.props;
      // value.forEach((valueOfKey, key) => {
      //   if (valueOfKey.size) {
      //     this.onRequest(key);
      //   }
      // });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props4 = this.props,
          value = _props4.value,
          itemGap = _props4.itemGap,
          layout = _props4.layout,
          labels = _props4.labels,
          getPopupContainer = _props4.getPopupContainer;
      var _state4 = this.state,
          data = _state4.data,
          keys = _state4.keys;


      return _react2.default.createElement(_dumb2.default, {
        getPopupContainer: getPopupContainer,
        layout: layout,
        itemGap: itemGap,
        labels: labels,
        onRequestTopLevel: function onRequestTopLevel() {
          _this3.requestData(keys.get(0));
        },
        onFocus: function onFocus(key) {
          _this3.onRequest(key);
        },
        onSearch: function onSearch(key, keyword) {
          var level = keys.indexOf(key);
          if (level > 0) {
            _this3.onRequest(key, keyword);
          }
        },
        data: data,
        keys: keys,
        value: value,
        onSelect: function onSelect(key, selected) {
          _this3.onSelect(key, selected);
        },
        onDeselect: function onDeselect(key, code) {
          _this3.onDeselect(key, code);
        }
      });
    }
  }]);
  return CategorySelector;
}(_react.PureComponent), _class2.propTypes = {
  onChange: _propTypes2.default.func,
  max: _propTypes2.default.number,
  onMax: _propTypes2.default.func,
  labels: _propTypes2.default.object,
  layout: _propTypes2.default.oneOf(['horizontal', 'vertical']),
  itemGap: _propTypes2.default.number,
  url: _propTypes2.default.string.isRequired,
  getPopupContainer: _propTypes2.default.func,
  defaultSelectedTopLevel: _propTypes2.default.bool
}, _class2.defaultProps = {
  max: _maxSafeInteger2.default,
  defaultSelectedTopLevel: true,
  onMax: function onMax() {}
}, _temp2), (_applyDecoratedDescriptor(_class.prototype, 'onSelect', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onSelect'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onDeselect', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onDeselect'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'onRequest', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onRequest'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'requestData', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'requestData'), _class.prototype)), _class);
exports.default = CategorySelector;
module.exports = exports['default'];