import React, {Component} from 'react';
import {Exception} from 'ola-ui-jd';
import {Divider} from 'ola-ui';
import {bind} from 'ola-toolkit';

export default class Demo extends Component {

  render() {
    return <div>
      <Exception type={'404'} gutter={60} text={<div style={{fontSize: 28, color: '#999'}}>404 - NOT FOUND</div>}/>
      <Divider dashed/>
      <Exception type={'error'}/>
      <Divider dashed/>
      <Exception type={'empty'}/>
      <Divider dashed/>
      <Exception type={'info'} text={'some information'}/>
    </div>
  }
}
