'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('ola-ui/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Timline = require('../Timline');

var _Timline2 = _interopRequireDefault(_Timline);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Forbidden = (_temp = _class = function (_PureComponent) {
  (0, _inherits3.default)(Forbidden, _PureComponent);

  function Forbidden() {
    (0, _classCallCheck3.default)(this, Forbidden);
    return (0, _possibleConstructorReturn3.default)(this, (Forbidden.__proto__ || (0, _getPrototypeOf2.default)(Forbidden)).apply(this, arguments));
  }

  (0, _createClass3.default)(Forbidden, [{
    key: 'render',
    value: function render() {

      var styles = require('./style.less');
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          title = _props.title,
          contacts = _props.contacts,
          footer = _props.footer,
          footerTitle = _props.footerTitle,
          footerButtonText = _props.footerButtonText,
          footerButtonOnClick = _props.footerButtonOnClick;


      return _react2.default.createElement(
        'div',
        { className: styles.container + ' ' + className, style: style },
        _react2.default.createElement('img', {
          width: 281, height: 274,
          src: 'http://storage.360buyimg.com/ola-ui/img/403.png',
          srcSet: 'http://storage.360buyimg.com/ola-ui/img/403_2x.png 2x, http://storage.360buyimg.com/ola-ui/img/403_3x.png 3x'
        }),
        _react2.default.createElement(
          'h2',
          { className: styles.heading },
          title
        ),
        contacts && contacts.length ? _react2.default.createElement(
          'div',
          { className: styles.contacts },
          contacts.map(function (contact) {
            return _react2.default.createElement(
              'div',
              { key: contact.erp, className: styles.item },
              _react2.default.createElement(_Timline2.default, { erp: contact.erp, name: contact.name }),
              _react2.default.createElement(
                'a',
                { href: 'mailto:' + contact.email },
                contact.email
              )
            );
          })
        ) : null,
        footer === true ? _react2.default.createElement(
          'div',
          { className: styles.footer },
          _react2.default.createElement(
            'h4',
            null,
            footerTitle
          ),
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _Button2.default,
              { type: 'primary', onClick: footerButtonOnClick },
              footerButtonText
            )
          )
        ) : null
      );
    }
  }]);
  return Forbidden;
}(_react.PureComponent), _class.propTypes = {
  className: _propTypes2.default.string,
  style: _propTypes2.default.object,
  title: _propTypes2.default.string,
  contacts: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    name: _propTypes2.default.string,
    erp: _propTypes2.default.string,
    email: _propTypes2.default.string
  })),

  footer: _propTypes2.default.oneOfType([_propTypes2.default.bool]),
  footerTitle: _propTypes2.default.string,
  footerButtonText: _propTypes2.default.string,
  footerButtonOnClick: _propTypes2.default.func
}, _class.defaultProps = {
  className: '',
  style: {},
  title: '对不起，您暂时无该系统的权限哦，如需开通，请联系以下童鞋。',
  contacts: [],
  footer: true,
  footerTitle: '想了解我们的其他产品么？跟我来。',
  footerButtonText: '查看详情',
  footerButtonOnClick: function footerButtonOnClick() {
    location.href = '//ola.jd.com';
  }
}, _temp);
exports.default = Forbidden;
module.exports = exports['default'];