'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getClass = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _uniform = require('../../styles/uniform');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getClass = exports.getClass = (0, _uniform.globalCls)('footer_');

var Footer = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(Footer, _Component);

  function Footer(props) {
    (0, _classCallCheck3.default)(this, Footer);
    return (0, _possibleConstructorReturn3.default)(this, (Footer.__proto__ || (0, _getPrototypeOf2.default)(Footer)).call(this, props));
  }

  (0, _createClass3.default)(Footer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          className = _props.className,
          year = _props.year,
          theme = _props.theme,
          department = _props.department;


      return _react2.default.createElement(
        'footer',
        { className: className + ' ' + getClass('container') + ' ' + theme, style: style },
        _react2.default.createElement(
          'div',
          { className: '' + getClass('brand') },
          department
        ),
        year && _react2.default.createElement(
          'div',
          { className: getClass('copyright') },
          'copyright@',
          year,
          ' JD.COM \u4EAC\u4E1C\u5546\u57CE \u7248\u6743\u6240\u6709'
        )
      );
    }
  }]);
  return Footer;
}(_react.Component), _class.propTypes = {

  style: _propTypes2.default.object,

  className: _propTypes2.default.string,

  year: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),

  theme: _propTypes2.default.oneOf(['light', 'dark']),

  department: _propTypes2.default.node
}, _class.defaultProps = {
  style: {},

  className: '',

  year: window.__OLA_TIMESTAMP__ ? new Date(window.__OLA_TIMESTAMP__).getFullYear() : null,

  theme: 'light',

  department: _react2.default.createElement(
    _react2.default.Fragment,
    null,
    _react2.default.createElement('img', { src: '//storage.360buyimg.com/ola-ui/img/logo-dept.png', width: 20 }),
    _react2.default.createElement(
      'span',
      null,
      '\u6280\u672F\u4E2D\u53F0 \xB7 \u6280\u672F\u8FD0\u8425\u5E73\u53F0\u90E8'
    )
  )
}, _temp);
exports.default = Footer;