'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getClass = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Icon = require('ola-ui/lib/components/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Select = require('ola-ui/lib/components/Select');

var _Select2 = _interopRequireDefault(_Select);

var _olaToolkit = require('ola-toolkit');

var _helpers = require('./helpers');

var _helpers2 = _interopRequireDefault(_helpers);

var _uniform = require('../../styles/uniform');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var getClass = exports.getClass = (0, _uniform.globalCls)('header_');

var Header = (_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Header, _Component);

  function Header(props) {
    (0, _classCallCheck3.default)(this, Header);
    return (0, _possibleConstructorReturn3.default)(this, (Header.__proto__ || (0, _getPrototypeOf2.default)(Header)).call(this, props));
  }

  (0, _createClass3.default)(Header, [{
    key: 'onBusinessLineChange',
    value: function onBusinessLineChange(biz) {
      var onBusinessLineChange = this.props.onBusinessLineChange;

      onBusinessLineChange(biz);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          showHomeLink = _props.showHomeLink,
          className = _props.className,
          userName = _props.userName,
          logoutUrl = _props.logoutUrl,
          returnUrl = _props.returnUrl,
          theme = _props.theme,
          left = _props.left,
          center = _props.center,
          Link = _props.Link,
          right = _props.right,
          app = _props.app,
          textApp = _props.textApp,
          logoTitle = _props.logoTitle,
          logoLink = _props.logoLink,
          onLogoClick = _props.onLogoClick,
          businessLineSelected = _props.businessLineSelected,
          businessLines = _props.businessLines;


      return _react2.default.createElement(
        'div',
        { className: className + ' ' + getClass('container') + ' ' + theme, style: style },
        _react2.default.createElement(
          'div',
          { className: getClass('left') },
          _react2.default.createElement(
            'h1',
            { title: logoTitle },
            _react2.default.createElement(
              Link,
              { className: getClass('brand'), href: logoLink, to: logoLink, onClick: onLogoClick },
              _react2.default.createElement('img', {
                src: '//storage.360buyimg.com/ola-ui/img/brand/logo.png',
                srcSet: '//storage.360buyimg.com/ola-ui/img/brand/logo_2x.png 2x, //storage.360buyimg.com/ola-ui/img/brand/logo_3x.png 3x',
                className: getClass('logoMajor') }),
              app && _react2.default.createElement('img', {
                src: '//storage.360buyimg.com/ola-ui/img/brand/' + app + '.png',
                srcSet: '//storage.360buyimg.com/ola-ui/img/brand/' + app + '_2x.png 2x, //storage.360buyimg.com/ola-ui/img/brand/' + app + '_3x.png 3x',
                className: getClass('logoMinor') }),
              textApp && _react2.default.createElement(
                'span',
                { className: getClass('logoMinorText') },
                textApp
              )
            )
          ),
          businessLines && (businessLines.length || businessLines.size) ? _react2.default.createElement(
            'div',
            { className: getClass('biz') },
            _react2.default.createElement(
              _Select2.default,
              { className: getClass('bizSelect'), value: businessLineSelected,
                onChange: this.onBusinessLineChange },
              businessLines.map(function (biz) {
                return _react2.default.createElement(
                  _Select2.default.Option,
                  { key: biz, value: biz },
                  biz
                );
              })
            )
          ) : null,
          left
        ),
        _react2.default.createElement(
          'div',
          { className: getClass('center') },
          center
        ),
        _react2.default.createElement(
          'div',
          { className: getClass('right') },
          showHomeLink && _react2.default.createElement(
            'a',
            { href: '//ola.jd.com', className: getClass('olaLink') },
            _react2.default.createElement(_Icon2.default, { type: 'home-back' }),
            '\u56DE\u5230\u6B27\u62C9'
          ),
          right,
          _react2.default.createElement(_helpers2.default, {
            logoutUrl: logoutUrl,
            returnUrl: returnUrl,
            userName: userName
          })
        )
      );
    }
  }]);
  return Header;
}(_react.Component), _class2.propTypes = {

  app: _propTypes2.default.string,

  textApp: _propTypes2.default.string,

  logoTitle: _propTypes2.default.string,

  logoLink: _propTypes2.default.string,

  onLogoClick: _propTypes2.default.func,

  style: _propTypes2.default.object,

  className: _propTypes2.default.string,

  left: _propTypes2.default.node,

  center: _propTypes2.default.node,

  right: _propTypes2.default.node,

  businessLines: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),

  businessLineSelected: _propTypes2.default.string,

  onBusinessLineChange: _propTypes2.default.func,

  userName: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element, _propTypes2.default.node]),

  logoutUrl: _propTypes2.default.string,

  returnUrl: _propTypes2.default.string,

  Link: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),

  theme: _propTypes2.default.oneOf(['light', 'dark']),

  showHomeLink: _propTypes2.default.bool
}, _class2.defaultProps = {
  style: {},

  className: '',

  logoLink: '/',

  Link: 'a',

  theme: 'light',

  showHomeLink: true,

  logoutUrl: '',

  onBusinessLineChange: function onBusinessLineChange() {}
}, _temp), (_applyDecoratedDescriptor(_class.prototype, 'onBusinessLineChange', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'onBusinessLineChange'), _class.prototype)), _class);
exports.default = Header;