'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.APP_READY = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

exports.appReady = appReady;
exports.default = initSagas;

var _effects = require('redux-saga/effects');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = /*#__PURE__*/_regenerator2.default.mark(appReady),
    _marked2 = /*#__PURE__*/_regenerator2.default.mark(initSagas);

var APP_READY = exports.APP_READY = '@@ola-ui/app_ready';

function appReady() {
  return _regenerator2.default.wrap(function appReady$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          try {
            document.querySelector('.ola-loading').remove();
          } catch (e) {}

        case 1:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked, this);
}

function initSagas() {
  return _regenerator2.default.wrap(function initSagas$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return (0, _effects.all)([(0, _effects.takeLatest)(APP_READY, appReady)]);

        case 2:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked2, this);
}